#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_OUTLINE_H
#include FT_STROKER_H
#include FT_GLYPH_H
#include FT_TRUETYPE_IDS_H

static FT_Library library;

int main(int argc, char** argv)
{
    FT_Error error = FT_Init_FreeType( &library );
    if ( error ) {
        return 1;
    }
    int i;

    FT_Face face;
    error = FT_New_Face( library, argv[1], 0, &face );
    if(error) {
        return 2;
    }
    FT_Set_Pixel_Sizes(face, 0, 10);

    char* str = argv[2];
    wchar_t ch = 0;
    FT_GlyphSlot  slot = face->glyph;
    int w = 0;
    int previous = 0;
    while( (ch = *str) != 0) {
        int glyph_index = FT_Get_Char_Index( face, ch );

        error = FT_Load_Glyph(face, glyph_index, FT_LOAD_DEFAULT|FT_LOAD_NO_BITMAP);
        str++;  
        w += slot->advance.x;
        if(previous && glyph_index )
    {
      FT_Vector  delta;
      FT_Get_Kerning( face, previous, glyph_index, FT_KERNING_DEFAULT, &delta );
            w += delta.x ;
    }
        previous = glyph_index;
    }
    printf("Width: %i\n", w/64);

    return 0;
}
